=== kernel/livepatch/Makefile ===
obj-$(CONFIG_LIVEPATCH) += livepatch.o

livepatch-objs := core.o
