## linux-euclid 4.4.0-9015.15.18

=== debian/changelog ===
linux-euclid (4.4.0-9015.15.18) xenial; urgency=low

  * workaround for WIFI NULL pointer dereference

 -- Wen-chien Jesse Sung <jesse.sung@canonical.com>  Fri, 03 Mar 2017 21:46:00 +0800

linux-euclid (4.4.0-9015.15) xenial; urgency=low

  * Miscellaneous Ubuntu changes
    - [Config] Set power button debounce to 5s on cs1p only

  * Miscellaneous upstream changes
    - input: soc_button_array: Add option to set debounce_interval
    - Ensure protex ignore list file is not ignored by git
    - Update the ignore list for Protex scan
    - Delete bdsignore files
    - Revert "Ensure protex ignore list file is not ignored by git"
    - scripts: Add gen_bdsignore for Protex scan
    - staging: iio: stm32l051: Fix first intr handling and get_ts api

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Wed, 02 Nov 2016 18:17:44 -0700

linux-euclid (4.4.0-9014.14) xenial; urgency=low

  * Miscellaneous upstream changes
    - Ignore the .git folder when doing IP scan.
    - staging: iio: stm32l051: Rebalance regulator control
    - Enable the feature of push power button for 5s and power off
    - Export the red LED control to user space
    - Rebind the volume up/down key on the top of CS1+ to virtual key F24 and F14.
      The user will use these keys in "Start->keyboard-> shortcuts".

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Sun, 09 Oct 2016 21:36:20 -0700

linux-euclid (4.4.0-9013.13) xenial; urgency=low

  * Rebase to master xenial tag Ubuntu-4.4.0-38.57

  * Miscellaneous upstream changes
    - staging: iio: stm32l051: use kthread_run instead for main thread
    - Move IRQ enabling after power on the device

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Thu, 22 Sep 2016 06:40:52 -0700

linux-euclid (4.4.0-9012.12) xenial; urgency=low

  * Rebase to master xenial tag Ubuntu-4.4.0-36.55

  * Miscellaneous upstream changes
    - Make the green LED always on when CS1 is on
    - Fix the wrong battery/charger status when turning on CS1+ with USB charger
      plugged in
    - Resolve wlan0 disappear after suspend
    - fix null pointer problem when system suspend
    - WIFI: Fixed boot&reboot crash sometimes
    - Add Wifi chip id 43341

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Wed, 07 Sep 2016 13:48:09 -0700

linux-euclid (4.4.0-9011.11) xenial; urgency=low

  * Miscellaneous Ubuntu changes
    - [Config] Run updateconfig
    - [Config] REVERTME: Enable WAKELOCK
    - [Config] Add cs1p flavour

  * Miscellaneous upstream changes
    - Add patch about audio suspend
    - Summary: add nc_device_state
    - ISH sensor Kernel code
    - ISH sensor kernel code
    - Audio Dmic record function
    - Fixed Bluetooth unable to open again
    - Export the LED1 control onCS1
    - ASoC: Intel: Remove invalid 10EC5640 acpi entry for cht-bsw
    - PM / Sleep: Add wake lock api wrapper on top of wakeup sources
    - Protex scan: add ignore list

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Wed, 03 Aug 2016 19:30:56 -0700

linux-euclid (4.4.0-9010.10) xenial; urgency=low

  * Miscellaneous upstream changes
    - fixed polling issue on stm32l051 driver

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Tue, 02 Aug 2016 22:46:15 -0700

linux-euclid (4.4.0-9009.9) xenial; urgency=low

  * Miscellaneous upstream changes
    - staging: iio: stm32l051: Re-add hw_time_stamp conversion to ns

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Sat, 30 Jul 2016 16:47:24 -0700

linux-euclid (4.4.0-9008.8) xenial; urgency=low

  * Miscellaneous upstream changes
    - staging: atomisp: Fix power sequence and context restore
    - staging: iio: stm32l051: Add usleep before i2c reads to avoid sporadic fails
    - Revert "i2c: designware: Performance improvement"

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Tue, 26 Jul 2016 19:18:42 -0700

linux-euclid (4.4.0-9007.7) xenial; urgency=low

  * Miscellaneous Ubuntu changes
    - [Config] Reboot immediatelly after panic

  * Miscellaneous upstream changes
    - i2c: designware: Performance improvement
    - staging: iio: stm32l051: HW TS IOCTL, new BW speeds and master mode ctrl
    - staging: iio: stm32l051: Set pa9 as input
    - staging: iio: stm32l051: Changes for tal for frequency and master mode fixes
    - Add alloy inclusion list.

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Thu, 30 Jun 2016 17:56:37 -0700

linux-euclid (4.4.0-9006.6) xenial; urgency=low

  * Miscellaneous Ubuntu changes
    - [Config] Remove lowlatency flavor for now
    - [Config] Add alloy flavor
    - [Config] Update configs to ov7251 3.3v usage

  * Miscellaneous upstream changes
    - staging: iio: stm32l051: Multidevs concurrent streaming
    - staging: iio: stm32l051: Refcount pmic
    - ov7251: Add kconfig option for using 3.3v
    - atomisp_gmin_platform: Use 3.3v only when ov7251 requires it
    - staging: iio: stm32l051: Fix variable overflow on timestamps

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Wed, 29 Jun 2016 09:00:49 -0700

linux-euclid (4.4.0-9005.5) xenial; urgency=low

  * Miscellaneous Ubuntu changes
    - [Config] Update configs

  * Miscellaneous upstream changes
    - staging: iio: stm32l051: Multidev support patch from Yanir
    - staging: iio: stm32l051: Reset overflow counters patch from Yanir

 -- Sergio Aguirre <sergio.a.aguirre.rodriguez@intel.com>  Thu, 16 Jun 2016 07:27:11 -0700

linux-euclid (4.4.0-9004.4) xenial; urgency=low

  * Miscellaneous Ubuntu changes
    - [Config] Enable REGULATOR CRC and WC
    - [Config] reconstruct -- Don't remove opregion driver
    - [Config] Disable BMG160 and BMA2X2 modules

  * Miscellaneous upstream changes
    - GPIO: crystalcove: Add actual missing support for WC
    - ACPI/PMIC: Revert to upstream driver
    - REVISIT: ACPI/PMIC: Make drivers work with current PMIC code
    - atomisp: platform: Add hard_vars for DS4t
    - ov7251: Re-enable power control

